using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DataGridViewEx1
{
    public partial class FormMatrix : Form
    {
        public FormMatrix()
        {
            InitializeComponent();
        }
        //  Form
        int m, n, p;    // 
        double[,] A, B, C;  // 
        const string SIZE = "   !";

        private void buttonCreate_Click(object sender, EventArgs e)
        {
            // 
            try
            {
                m = Convert.ToInt32(textBoxM.Text);
                n = Convert.ToInt32(textBoxN.Text);
                p = Convert.ToInt32(textBoxP.Text);
                A = new double[m, n];
                B = new double[n, p];
                C = new double[m, p];
                // DGView,    
                int k = 0;
                k = dataGridViewMatrixA.ColumnCount;
                if (k != 0)
                    for (int i = 0; i < k; i++)
                        dataGridViewMatrixA.Columns.RemoveAt(0);
                dataGridViewMatrixB.Columns.Clear();
                // dataGridView3.DataSource = C;
                dataGridViewMatrixC.Columns.Clear();
                // DGView  
                AddColumns(n, dataGridViewMatrixA);
                AddColumns(p, dataGridViewMatrixB);
                AddColumns(p, dataGridViewMatrixC);
                // DGView 
                AddRows(m, dataGridViewMatrixA);
                AddRows(n, dataGridViewMatrixB);
                AddRows(m, dataGridViewMatrixC);
            }
            catch (Exception)
            {
                labelSize.Text = SIZE;
            }
        }
        private void AddColumns(int n, DataGridView dgw)
        {
            // n     dgw
            // DGView 
            DataGridViewColumn column;
            for (int i = 0; i < n; i++)
            {
                column = new DataGridViewTextBoxColumn();
                column.DataPropertyName = "Column" + i.ToString();
                column.Name = "Column" + i.ToString();
                dgw.Columns.Add(column);
            }           
        }
        private void AddRows(int m, DataGridView dgw)
        {
            // m     dgw            
            // DGView 
            for (int i = 0; i < m; i++)
            {
                dgw.Rows.Add();
                dgw.Rows[i].HeaderCell.Value
                    = "row" + i.ToString();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string elem = "";
            bool correct = true;
            for (int i = 0; i < m; i++)
                for (int j = 0; j < n; j++)
                {                    
                   try
                    {
                      elem=dataGridViewMatrixA.Rows[i].Cells[j].Value.ToString();
                      A[i, j] = Convert.ToDouble(elem);
                      label8.Text = "";  
                    }
                    catch (Exception )
                    {
                        label8.Text = " " +
                          "A[" + i.ToString() +", " + j.ToString() + " ]"
                         + "  .  !";
                        dataGridViewMatrixA.Rows[i].Cells[j].Selected= true;
                        return;
                    }                   
                }
            for (int i = 0; i < n; i++)
                for (int j = 0; j < p; j++)
                {
                    do
                    {
                        correct = true;
                        try
                        {
                            elem = dataGridViewMatrixB.Rows[i].Cells[j].Value.ToString();
                            
                                B[i, j] = Convert.ToDouble(elem);
                            label9.Text = "";
                        }
                        catch (Exception )
                        {
                            label9.Text = " " +
                             "B[" + i.ToString() + ", " + j.ToString() + " ]"
                            + "  .  !";
                            dataGridViewMatrixB.Rows[i].Cells[j].Selected=true;
                            FormCorrection frm = new FormCorrection();
                            frm.label1.Text = 
                                "B[" + i.ToString() + ", " + j.ToString() + " ] =";
                            frm.ShowDialog();
                            dataGridViewMatrixB.Rows[i].Cells[j].Value = frm.textBox1.Text;
                            correct = false;
                        }
                    } while (!correct);                    
                }
        }
        void MultMatr(double[,] A, double[,] B, double[,] C)
        {
            int m = A.GetLength(0);
            int n = A.GetLength(1);
            int p = B.GetLength(1);
            double S =0;
            for(int i=0; i<m; i++)
                for (int j = 0; j < p; j++)
                {
                    S = 0;
                    for (int k = 0; k < n; k++)
                        S += A[i, k] * B[k, j];
                    C[i, j] = S;
                }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            MultMatr(A, B, C);
            FillDG();
            //dataGridView3.Show();
        }
        void FillDG()
        {
            for (int i = 0; i < m; i++)
                for (int j = 0; j < p; j++)
                    dataGridViewMatrixC.Rows[i].Cells[j].Value
                        = C[i, j].ToString();
        }

       
    }
}